module Xfabricator

  class TemplateDefinition

    attr_reader :template_files
    attr_reader :variable_prompts

    def TemplateDefinition.load_definition(template_def_file)
      unless template_def_file
        raise ArgumentError, 'config file not specified'
      end

      unless template_def_file.exist?
        raise ArgumentError, "template definition file doesn't exist: #{template_def_file}"
      end

     template_def = eval(File.read(template_def_file.to_s), binding)

      unless template_def
        raise RuntimeError, "template definition was not loaded"
      end

      unless template_def.is_a? TemplateDefinition
        raise RuntimeError, "Valid template definition not loaded"
      end

      return template_def
    end

    def initialize(files, variable_prompts)
      @template_files = files
      @variable_prompts = variable_prompts
    end

    def TemplateDefinition.create_definition(definition)
      options = {}
      definition.call(options)
      TemplateDefinition.new options[:template_files], options[:variable_prompts]
    end

  end

  class TemplateFileDefinition

    attr_reader :output_name_template
    attr_reader :template_file
    attr_reader :sub_path

    def initialize(template_file, output_name_template, sub_path = '')
      @output_name_template = output_name_template
      @template_file = template_file
      @sub_path = sub_path
    end

  end

end