require 'mustache'

module Xfabricator

  class XCodeFileTemplate < Mustache

    # {{#configurations}}
    #   {{.}}
    # {{/configurations}}

    # {{template_variable}}

    # {{#build_setting}}build_configuration.variable{{/build_setting}}

    def initialize(project, variables)
      super({})
      @project = project

      self[:configurations] = @project.build_configurations.collect do |config|
        config.name
      end

      variables.each do |key,value|
        self[key] = value
      end
    end

    def build_setting
      lambda { |key|
        config = key.split('.').first
        setting_name = key.split('.').last
        settings = @project.build_settings config
        return settings[setting_name]
      }
    end

  end


end
