require 'xcodeproj'

module Xfabricator

  module PBXGroupAdditions

    def xfab_create_subpath(path)
      return self unless path

      path = path.split('/') unless path.is_a?(Array)
      child_name = path.shift
      child = children.find { |c| c.display_name == child_name }

      if child.nil?
        child = new_group(nil, child_name)
      end

      if path.empty?
        [ child ]
      else
        [ child ].concat child.xfab_create_subpath(path)
      end
    end

  end

  Xcodeproj::Project::Object::PBXGroup.include PBXGroupAdditions

end
